﻿// chapter-1.cpp : 

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "wavefile.h"

#define SRATE 	44100 // サンプリングレート 44.1kHz
#define PI 3.1415928
FILE* outfp;
char filename[10] = "out.wav";

int main()
{
	MONO_PCM  pcm;		// モノラルのPCMヘッダ
	pcm.fs = SRATE; 			// サンプリングレート
	pcm.bits = 16; 				// 量子化精度
	pcm.length = SRATE * 10.0; 	// データの長さ 10sec
	pcm.s = (double*)calloc(pcm.length, sizeof(double));  //メモリ確保

	double amplitude;			// 振幅、周波数
	amplitude = 0.5; 			// 振幅
	double f0 = 523.25;			// ド C5の周波数 Hz
	double f1 = f0 * 1.25;		// ミ　純正律の場合の周波数 Hz
	//double f1 = f0 * 1.259921;	// ミ　平均律の場合の周波数 Hz
	//double f1 = f0 * 1.5;			// ソ　純正律の場合の周波数 Hz
	//double f1 = f0 * 1.498307;	// ソ　平均律の場合の周波数 Hz

	// sin波のデータ生成
	unsigned int count;
	int n = 3;
	for (count = 0; count < pcm.length; count++) {
		// 3秒間ドを鳴らす
		if (count < 3.0 * SRATE) {
			pcm.s[count] = amplitude * sin(2.0 * PI * f0 * count / pcm.fs);
			pcm.s[count] += amplitude/2.0 * sin(2.0 * PI * f0*2.0 * count / pcm.fs);
			pcm.s[count] += amplitude/3.0 * sin(2.0 * PI * f0*3.0 * count / pcm.fs);
			pcm.s[count] /= 3.0;
		}
		// 次の3秒間ミを鳴らす
		else if (count < 6.0 * SRATE) {
			pcm.s[count] = amplitude * sin(2.0 * PI * f1 * count / pcm.fs);
			pcm.s[count] += amplitude/2.0 * sin(2.0 * PI * f1*2.0 * count / pcm.fs);
			pcm.s[count] += amplitude/3.0 * sin(2.0 * PI * f1*3.0 * count / pcm.fs);
			pcm.s[count] /= 3.0;
		}
		// ドとミを同時に鳴らす
		else {
			pcm.s[count] = amplitude * sin(2.0 * PI * f0 * count / pcm.fs);
			pcm.s[count] += amplitude / 2.0 * sin(2.0 * PI * f0 * 2.0 * count / pcm.fs);
			pcm.s[count] += amplitude / 3.0 * sin(2.0 * PI * f0 * 3.0 * count / pcm.fs);
			pcm.s[count] += amplitude * sin(2.0 * PI * f1 * count / pcm.fs);
			pcm.s[count] += amplitude / 2.0 * sin(2.0 * PI * f1 * 2.0 * count / pcm.fs);
			pcm.s[count] += amplitude / 3.0 * sin(2.0 * PI * f1 * 3.0 * count / pcm.fs);
			pcm.s[count] /= 6.0;

		}
	}

	// WAVファイルに書き出す
	wavWriteMono(&pcm, filename);
	free(pcm.s);

	return 0;
}

// プログラムの実行: Ctrl + F5 または [デバッグ] > [デバッグなしで開始] メニュー
// プログラムのデバッグ: F5 または [デバッグ] > [デバッグの開始] メニュー
