﻿// chapter-1.cpp : 

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "wavefile.h"

#define SRATE 	44100 // サンプリングレート 44.1kHz
#define PI 3.1415928
FILE* outfp;
char filename[10] = "out.wav";

int main()
{
	MONO_PCM  pcm;		// モノラルのPCMヘッダ
	pcm.fs = SRATE; 			// サンプリングレート
	pcm.bits = 16; 				// 量子化精度
	pcm.length = SRATE * 8.0; 	// データの長さ 8sec
	pcm.s = (double*)calloc(pcm.length, sizeof(double));  //メモリ確保
	
	double amplitude;			// 振幅、周波数
	amplitude = 0.5; 			// 振幅
	double f0 = 261.63;			// ド C4の周波数 Hz
	// 平均律音階のドレミファソラシドの各音程の比率
	double ratio[8] = {1.0, 1.122462048, 1.25992105, 1.334839854, 1.49830707, 1.681792831, 1.887748625, 2.0};
	// 純正律音階のドレミファソラシドの各音程の比率
//	double ratio[8] = { 1.0, 9.0/8.0, 5.0/4.0, 4.0/3.0, 3.0/2.0, 5.0/3.0, 15.0/8.0, 2.0 };
	// ピタゴラス音階のドレミファソラシドの各音程の比率
//	double ratio[8] = { 1.0, 9.0/8.0, 81.0/64.0, 4.0 / 3.0, 3.0 / 2.0, 27.0 / 16.0, 243.0 / 128.0, 2.0 };


	// sin波のデータ生成
	unsigned int count;
	int n = 0;
	// 1秒ずつ音階を出力する
	for (n = 0; n < 8; n++){
		double fi = f0 * ratio[n];
		for (count = 0; count < SRATE; count++) {
			pcm.s[count + n * SRATE] = amplitude * sin(2.0 * PI * fi * count / pcm.fs);
			pcm.s[count + n * SRATE] += amplitude/2.0 * sin(2.0 * PI * fi*2.0 * count / pcm.fs);
			pcm.s[count + n * SRATE] += amplitude/3.0 * sin(2.0 * PI * fi*3.0 * count / pcm.fs);
			pcm.s[count + n * SRATE] /= 3.0;
		}
	}

	// WAVファイルに書き出す
	wavWriteMono(&pcm, filename);
	free(pcm.s);

	return 0;
}

// プログラムの実行: Ctrl + F5 または [デバッグ] > [デバッグなしで開始] メニュー
// プログラムのデバッグ: F5 または [デバッグ] > [デバッグの開始] メニュー
