// WAV(m)t@CtH[}bg̓ǂݍ݂Əo
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

// constant
#define Base 32768
#define Max 65536
#define Min 0.0

typedef struct
{
	int fs;		// W{g
	int bits;	// ʎq
	int length;	// 
	double *s;	// f[^
} MONO_PCM;

typedef struct
{
    char chunkID[4];
    long chunkSize;
    char chunkFormType[4];
} RIFF_CHUNK;

typedef struct
{
	char chunkID[4];
	long chunkSize;
	short waveFormatType;
	short formatChannel;
	long samplesPerSec;
	long bytesPerSec;
	short blockSize;
	short bitsPerSample;
} FMT_CHUNK;

typedef struct
{
	char chunkID[4];
	long chunkSize;
	short data;
} DATA_CHUNK;

typedef struct
{
	RIFF_CHUNK riffChunk;
	FMT_CHUNK fmtChunk;
	DATA_CHUNK dataChunk;
} WAVE_FORMAT;

void wavReadMono(MONO_PCM *pcm, char *fname);
void wavWriteMono(MONO_PCM *pcm, char *fname);

void wavReadMono(MONO_PCM *pcm, char *fname)
{
	FILE *fp;
	int i;
	WAVE_FORMAT waveFormat;

	fopen_s(&fp,fname, "rb");
	if(!fp){
		printf("File open error !\n");
		exit(0);
	}

	fread(waveFormat.riffChunk.chunkID, 1, 4, fp);
	fread(&waveFormat.riffChunk.chunkSize, 4, 1, fp);
	fread(waveFormat.riffChunk.chunkFormType, 1, 4, fp);

	fread(waveFormat.fmtChunk.chunkID, 1, 4, fp);
	fread(&waveFormat.fmtChunk.chunkSize, 4, 1, fp);
	fread(&waveFormat.fmtChunk.waveFormatType, 2, 1, fp);
	fread(&waveFormat.fmtChunk.formatChannel, 2, 1, fp);
	fread(&waveFormat.fmtChunk.samplesPerSec, 4, 1, fp);
	fread(&waveFormat.fmtChunk.bytesPerSec, 4, 1, fp);
	fread(&waveFormat.fmtChunk.blockSize, 2, 1, fp);
	fread(&waveFormat.fmtChunk.bitsPerSample, 2, 1, fp);

	fread(waveFormat.dataChunk.chunkID, 1, 4, fp);
	fread(&waveFormat.dataChunk.chunkSize, 4, 1, fp);

	pcm->fs = waveFormat.fmtChunk.samplesPerSec;
	pcm->bits = waveFormat.fmtChunk.bitsPerSample;
	pcm->length = waveFormat.dataChunk.chunkSize;
	pcm->s = (double *)calloc(pcm->length, sizeof(double));

	short data;
	for(int i = 0; i < pcm->length; i++)
	{
		fread(&data, 2, 1, fp);
		pcm->s[i] = (double)data / 32768.0;
	}

	fclose(fp);
}

void wavWriteMono(MONO_PCM *pcm, char *fname)
{
    FILE *fp;
    WAVE_FORMAT waveFormat;

	waveFormat.riffChunk.chunkID[0] = 'R';
	waveFormat.riffChunk.chunkID[1] = 'I';
	waveFormat.riffChunk.chunkID[2] = 'F';
	waveFormat.riffChunk.chunkID[3] = 'F';
	waveFormat.riffChunk.chunkSize = 36 + pcm->length * 2;
	waveFormat.riffChunk.chunkFormType[0] = 'W';
	waveFormat.riffChunk.chunkFormType[1] = 'A';
	waveFormat.riffChunk.chunkFormType[2] = 'V';
	waveFormat.riffChunk.chunkFormType[3] = 'E';

	waveFormat.fmtChunk.chunkID[0] = 'f';
	waveFormat.fmtChunk.chunkID[1] = 'm';
	waveFormat.fmtChunk.chunkID[2] = 't';
	waveFormat.fmtChunk.chunkID[3] = ' ';
    waveFormat.fmtChunk.chunkSize = 16;
    waveFormat.fmtChunk.waveFormatType = 1; // PCM̏ꍇ1
    waveFormat.fmtChunk.formatChannel = 1;  // m̏ꍇ1,XeȈꍇ2
    waveFormat.fmtChunk.samplesPerSec = pcm->fs;
    waveFormat.fmtChunk.bytesPerSec = (pcm->fs * pcm->bits) / 8;
    waveFormat.fmtChunk.blockSize = pcm->bits / 8;
    waveFormat.fmtChunk.bitsPerSample = pcm->bits;

	waveFormat.dataChunk.chunkID[0] = 'd';
	waveFormat.dataChunk.chunkID[1] = 'a';
	waveFormat.dataChunk.chunkID[2] = 't';
	waveFormat.dataChunk.chunkID[3] = 'a';
    waveFormat.dataChunk.chunkSize = pcm->length * 2;

    fopen_s(&fp, fname, "wb");
    if(!fp){
        printf("file open error");
        exit(0);
    }

    fwrite(waveFormat.riffChunk.chunkID, 1, 4, fp);
    fwrite(&waveFormat.riffChunk.chunkSize, 4, 1, fp);
    fwrite(waveFormat.riffChunk.chunkFormType, 1, 4, fp);

    fwrite(waveFormat.fmtChunk.chunkID, 1, 4, fp);
    fwrite(&waveFormat.fmtChunk.chunkSize, 4, 1, fp);
    fwrite(&waveFormat.fmtChunk.waveFormatType, 2, 1, fp);
    fwrite(&waveFormat.fmtChunk.formatChannel, 2, 1, fp);
    fwrite(&waveFormat.fmtChunk.samplesPerSec, 4, 1, fp);
    fwrite(&waveFormat.fmtChunk.bytesPerSec, 4, 1, fp);
    fwrite(&waveFormat.fmtChunk.blockSize, 2, 1, fp);
    fwrite(&waveFormat.fmtChunk.bitsPerSample, 2, 1, fp);

    fwrite(waveFormat.dataChunk.chunkID, 1, 4, fp);
    fwrite(&waveFormat.dataChunk.chunkSize, 4, 1, fp);

	// write data
	short data;
	double s;
	for (int i = 0; i < pcm->length; i++){
		s = (pcm->s[i] + 1.0) / 2.0 * 65536.0;
		if (s > 65535.0){
			s = 65535.0; /* NbsO */
		}
		else if (s < 0.0){
			s = 0.0; /* NbsO */
		}
		data = (short)(s + 0.5) - 32768; 
		fwrite(&data, 2, 1, fp);
	}

	fclose(fp);
}



